From 38331568fbfdd2169733a28ce13c809c46c70e12 Mon Sep 17 00:00:00 2001
From: David Powell <djpowell@djpowell.net>
Date: Sat, 5 Jun 2010 17:09:04 +0100
Subject: [PATCH 6/6] write to stdin from a separate thread to prevent stdout blocking before we write anything

---
 src/clj/clojure/java/shell.clj |    5 +++--
 1 files changed, 3 insertions(+), 2 deletions(-)

diff --git a/src/clj/clojure/java/shell.clj b/src/clj/clojure/java/shell.clj
index 1929e32..bbe46d0 100644
--- a/src/clj/clojure/java/shell.clj
+++ b/src/clj/clojure/java/shell.clj
@@ -111,8 +111,9 @@ collecting its stdout"}
 		    (as-env-string (:env opts))
 		    (as-file (:dir opts)))]
     (if (:in opts)
-      (with-open [osw (OutputStreamWriter. (.getOutputStream proc) (:inenc opts))]
-        (.write osw (:in opts)))
+      (future
+       (with-open [osw (OutputStreamWriter. (.getOutputStream proc) (:inenc opts))]
+         (.write osw (:in opts))))
       (.close (.getOutputStream proc)))
     (with-open [stdout (.getInputStream proc)
                 stderr (.getErrorStream proc)]
-- 
1.6.5.1.1367.gcd48

